#!/usr/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_www_report.pl
#
# Changes:
# 
#   bb 12Jun00 - Initial
# 23Nov05 - bb - 1.01 - Fixed/improved informix lightbulb
# 23Dec05 - bb - 1.02 - Added ssh informix capability
# =========================================================
$version = "1.02";

$debug = 1;

$| = 1;
chop($P = `basename $0`);
$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
$os = $ENV{"ORACLE_SID"};

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";

$tmpfile = "/tmp/${P}_$$.txt";
$tmprpt = "/tmp/${P}_rpt_$$.txt";

$mode =  $ARGV[0];
$inst =  $ARGV[1];
$zcli =  $ARGV[2];
$ckin =  $ARGV[3];

#$ssh_slash = "f";
$ssh_slash = "b";

$arg3 = $ARGV[4];
$arg4 = $ARGV[5];

if ($ckin eq "" || $ckin eq ".")
{
  $modein    = $ARGV[0];
  $dbcfilein = $ARGV[1];
}

$dbamon_userid = "dbamon";

#------------------------------------------------------------------------------
sub trim
#------------------------------------------------------------------------------
{
  my @out = @_;
  for (@out)
  {
    s/^\s+//;
    s/\s+$//;
  }
  return wantarray ? @out : $out[0];
}

#------------------------------------------------------------------------------
sub msgOld
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | $msgmsg\n"; }
}

#------------------------------------------------------------------------------
sub msgRed
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | <font color=red><b>$msgmsg</b></font>\n"; }
}

#------------------------------------------------------------------------------
sub bg
#------------------------------------------------------------------------------
{
  if ($lastbg == 1)
  {
    $lastbg = 0;
    return "bgcolor=ffffff"; 
  }
  else
  {
    $lastbg = 1;
    return "bgcolor=lightgrey"; 
  }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  my $msg   = $_[0];

  print "
  <table bgcolor=red>
  <tr><th bgcolor=pink ><font size=2>Fatal Error: </font>
  <tr><th bgcolor=white><font size=2>$msg </font>
  </table>
  <br>";

  &msg("Exiting rc=1");
  exit 1;
}

#------------------------------------------------------------------------------
sub connectDBOld
#------------------------------------------------------------------------------
{
  ##&msg("Connecting to DBAmon Oracle Repository DB to read DBC data");
  use DBI;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $os;

  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
  $dbh->{LongReadLen} = 4000;
}

#-----------------------------------------------------------------------------
sub remshDBInformix
#-----------------------------------------------------------------------------
{
  &msg("remsh'ing to Host=$Host Userid=$Userid");

  $lstring = "-l $Userid" if $Userid ne "";

  if ($Inf_Server eq "")
  {
    $_ = $Config;
    @words = split(/\//);
    $Inf_Server = $words[0];
    $ON_Config = $words[1];
    ##print "$Inf_Server $ON_Config \n";
  }

  $Informix_Dir = $INFORMIXDIR if ! $Informix_Dir;
  $Inf_Server   = $INFORMIXSERVER if ! $Inf_Server;
  $ON_Config    = $ONCONFIG if ! $ON_Config;

  $cmdpfx = "remsh $Host $lstring '" .
    "export WWW=Y; ".
    "export INFORMIXDIR=$Informix_Dir; ".
    "export INFORMIXSERVER=$Inf_Server; ". 
    "export ONCONFIG=$ON_Config; ".
    "export PATH=\$PATH:$Informix_Dir/bin; ";

  #"/tmp/dbamon_inf.pl status '";

  &msg("Env: INFORMIXDIR=$Informix_Dir INFORMIXSERVER=$Inf_Server ONCONFIG=$ON_Config");
  $cmd = "$cmdpfx $probe_dir/dbamon_inf.pl www_status"; 
  &msg("Issuing: $cmd");

  ##&msg("DEBUG cmdpfx=$cmdpfx");
  #system("$cmdpfx onstat -m;onstat -d 2>&1");
  system("$cmd up 2>&1");

}

#-----------------------------------------------------------------------------
sub sshDBInformix
#-----------------------------------------------------------------------------
{
  &msg("remsh'ing to Host=$Host Userid=$Userid");

  $lstring = "-l $Userid" if $Userid ne "";

  if ($Inf_Server eq "")
  {
    $_ = $Config;
    @words = split(/\//);
    $Inf_Server = $words[0];
    $ON_Config = $words[1];
    ##print "$Inf_Server $ON_Config \n";
  }

  $Informix_Dir = $INFORMIXDIR if ! $Informix_Dir;
  $Inf_Server   = $INFORMIXSERVER if ! $Inf_Server;
  $ON_Config    = $ONCONFIG if ! $ON_Config;

  $cmdpfx = "ssh $Host $lstring '" .
    "export WWW=Y; ".
    "export INFORMIXDIR=$Informix_Dir; ".
    "export INFORMIXSERVER=$Inf_Server; ". 
    "export ONCONFIG=$ON_Config; ".
    "export PATH=\$PATH:$Informix_Dir/bin; ";

  &msg("Env: INFORMIXDIR=$Informix_Dir INFORMIXSERVER=$Inf_Server ONCONFIG=$ON_Config");
  $cmd = "$cmdpfx $probe_dir/dbamon_inf.pl www_status"; 
  &msg("Issuing: $cmd");

  ##&msg("DEBUG cmdpfx=$cmdpfx");
  #system("$cmdpfx onstat -m;onstat -d 2>&1");
  
  system("$cmd up 2>&1");
}

#-----------------------------------------------------------------------------
sub downloadNTSCP
#-----------------------------------------------------------------------------
{
  if ($DBMS eq "MSSQL")    { $filemask = "mssql" }
  if ($DBMS eq "OracleNT") { $filemask = "orant" }

  &msg("downloadNTSCP: Downloading (scp) DBAmon software to NT Host=$Host Userid=$Userid");

  if ($ssh_slash eq "f")
  {
    $cmd = "scp /opt/dbamon/bin/download/*${filemask}* '$Userid\@$Host:/tmp' 2>&1";
  }
  else
  {
    #$cmd = "scp /opt/dbamon/bin/download/*${filemask}* '$Userid\@$Host:\\\\temp' 2>&1";
    $cmd = "scp /opt/dbamon/bin/download/*${filemask}* '$Userid\@$Host:' 2>&1";
  }

  &msg("cmd=$cmd");
  if (system("$cmd 2>&1") != 0)
  {
    &error("Cannot download DBAmon software to $Host");
  }
  &msg("Download Ended RC=0");
}

#-----------------------------------------------------------------------------
sub downloadNT
#-----------------------------------------------------------------------------
{
  if ($DBMS eq "MSSQL")    { $filemask = "mssql" }
  if ($DBMS eq "OracleNT") { $filemask = "orant" }

  &msg("downloadNT: Downloading (rcp) DBAmon software to NT Host=$Host Userid=$Userid");
  $cmd = "remsh $Host 'rcp ${wsnamef}.${dbamon_userid}:/opt/dbamon/bin/download/*${filemask}* /temp' 2>&1";
  &msg("cmd=$cmd");
  if (system("$cmd") != 0)
  {
    &error("Cannot download DBAmon software to $Host");
  }
  &msg("Download Successful");
}


#-----------------------------------------------------------------------------
sub download
#-----------------------------------------------------------------------------
{
  #if    ($DBMS eq "Informix")   { $filemask = '*'; }
  #elsif ($DBMS eq "OracleNT")   { $filemask = '*'; }
  #elsif ($DBMS eq "MSSQL")      { $filemask = '*'; }
  #elsif ($DBMS eq "SAP")        { $filemask = '*'; }
  #elsif ($DBMS eq "OracleApps") { $filemask = '*'; }
  #elsif ($DBMS eq "Oracle")     { $filemask = 'dbamon_ora.*' } 
  #elsif ($DBMS eq "MSSQL")      { $filemask = '*'; }
  #else                          { $filemask = '*'; }

  $probe_dir = "/tmp/DBAmon_${Userid}"; 

  &msg("download: Downloading (rcp) DBAmon software to Host=$Host Userid=$Userid $probe_dir");
  if (system("rcp /opt/dbamon/bin/download/* $Userid\@$Host:$probe_dir 2>&1") != 0)
  {
    &error("Cannot download DBAmon software to $Userid\@$Host $probe_dir");
  }
  ##&msg("Download Successful");
}

#-----------------------------------------------------------------------------
sub downloadSCP
#-----------------------------------------------------------------------------
{
  $probe_dir = "/tmp/DBAmon_${Userid}"; 
  $attempt = 0; 

  DOWNLOAD_SCP: $attempt++; 
  &msg("downloadSCP: Downloading (scp) DBAmon software to Host=$Host Userid=$Userid $probe_dir");

  system("scp /opt/dbamon/bin/download/* $Userid\@$Host:$probe_dir 2>&1 | tee $tmpfile"); 

  ##$z = length(`cat $tmpfile`); 
  ##print "z=$z\n";

  if (`cat $tmpfile` =~ /No such file or directory/ && $attempt < 3)
  {
    &msg("Directory $probe_dir must be missing - attempting to create"); 
    $lstring = "-l $Userid" if $Userid ne "";
    system("ssh $lstring $Host 'mkdir $probe_dir'"); 
    &msg("Retrying proble download"); 
    goto DOWNLOAD_SCP;
  }
  if (length(`cat $tmpfile`) > 0)
  {
    &error("Probe software download error - $Userid\@$Host $probe_dir");
  }

  ##&msg("Download Successful");
}

#-----------------------------------------------------------------------------
sub remshDBOracleNT
#-----------------------------------------------------------------------------
{
  &msg("remsh'ing to Host=$Host Userid=$Userid ORACLE_HOME=$ORACLE_HOME ORACLE_SID=$ORACLE_SID");

  $lstring = "-l $Userid" if $Userid ne "";

  $cmdpfx = "remsh $Host $lstring '";

  if ($Perl_Path ne "")
  {
    $perlpath = "$Perl_Path";
  }
  else
  {
    $perlpath = "perl";
  }

  &msg("Issuing: $perlpath \\temp\\dbamon_orant.pl $ORACLE_SID up WWW");
  ##print "cmd=$cmdpfx $perlpath \\temp\\dbamon_orant.pl $ORACLE_SID up WWW\n"; 
  system("$cmdpfx$perlpath \\temp\\dbamon_orant.pl $ORACLE_SID up WWW' 2>&1");

  #&msg("Issuing: $perlpath \\temp\\dbamon_orant.pl $ORACLE_SID bkup");
  #system("$cmdpfx$perlpath \\temp\\dbamon_orant.pl $ORACLE_SID bkup' 2>&1");
}

#-----------------------------------------------------------------------------
sub remshOraApps
#-----------------------------------------------------------------------------
{
  &msg("remsh'ing to Host=$Host Userid=$Userid");

  $lstring = "-l $Userid" if $Userid ne "";

  $cmdpfx = "remsh $Host $lstring '" .
    "export ORACLE_HOME=$ORACLE_HOME; ".
    "export ORACLE_SID=$ORACLE_SID; ". 
    "export PATH=\$PATH:$ORACLE_HOME/bin; ";

  $cmdparm = "$probe_dir/dbamon_oraap.pl up $OraApps_Userid $OraApps_Minproc_Apache $OraApps_COMN_Dir $OraApps_Forms_ORAHOME $OraApps_FS_Check 2>&1";
  &msg("Issuing: $cmdparm");
  system("$cmdpfx $cmdparm ");

}

#-----------------------------------------------------------------------------
sub remshDBOracle
#-----------------------------------------------------------------------------
{
  &msg("remsh'ing to Host=$Host Userid=$Userid");

  $lstring = "-l $Userid" if $Userid ne "";

  $cmdpfx = "remsh $Host $lstring '" .
    "ll $probe_dir/dbamon_ora.pl; ".
    "export WWW=Y; ".
    "export ORACLE_HOME=$ORACLE_HOME; ".
    "export ORACLE_SID=$ORACLE_SID; ". 
    "export PATH=\$PATH:$ORACLE_HOME/bin; ";

  &msg("Issuing:  $cmdpfx $probe_dir/dbamon_ora.pl report_$arg3 > $tmprpt 2>&1");
  system("$cmdpfx $probe_dir/dbamon_ora.pl report_$arg3' > $tmprpt 2>&1");
  &reportProcess;
}

#-----------------------------------------------------------------------------
sub sshDBOracle
#-----------------------------------------------------------------------------
{
  &msg("ssh'ing to Host=$Host Userid=$Userid");

  $lstring = "-l $Userid" if $Userid ne "";

  #if ($INF_Server eq "")
  #{
  #  $_ = $Config;
  #  @words = split(/\//);
  #  $Inf_Server = $words[0];
  #  $ON_Config = $words[1];
  #  ##print "$Inf_Server $ON_Config \n";
  #}

  $cmdpfx = "ssh $lstring $Host '" .
    "export WWW=Y; ".
    "export ORACLE_HOME=$ORACLE_HOME; ".
    "export ORACLE_SID=$ORACLE_SID; ". 
    "export PATH=\$PATH:$ORACLE_HOME/bin; ";

  &msg("Issuing:  $cmdpfx $probe_dir/dbamon_ora.pl report_$arg3 > $tmprpt 2>&1");
  system("$cmdpfx $probe_dir/dbamon_ora.pl report_$arg3' > $tmprpt 2>&1");
  &reportProcess;
}

#-----------------------------------------------------------------------------
sub reportProcess
#-----------------------------------------------------------------------------
{
  &msg("reportProcess - Formatting report"); 

  #system("ll $tmprpt"); 
  #system("cat $tmprpt"); 
  #exit;
  
  print "<hr>"; 
  
  print "<table bgcolor=linen border=0><tr><td><pre><font size=2><br>";
  ##system("grep -v 'dbamon_ora.pl' $tmprpt | grep -v '/tmp'"); 
  foreach (`cat $tmprpt `)
  {
    next if /dbamon_ora/;
    next if /\/tmp/;
    $line = substr($_,5); 
    chop $line; 
    print "$line\n"; 
  }

  $tmphtml = "/opt/web/dba/tmp/${P}_$$.html";
  system "echo '<body bgcolor=white><font size=2 face=verdana>
   (Right-Click anywhere on any of the below table(s), then select <b>Export to Microsoft Excel</b>)<p>' > $tmphtml"; 
  system "grep '^RPT:' $tmprpt | sed s/RPT://g  >> $tmphtml 2>&1"; 
  system "echo '</pre>' >> $tmphtml"; 
  ##system "ll $tmphtml 2>&1"; 
  
  print "\n(<a href='http://dba.it.thecompany.com/dba/tmp/${P}_$$.html'><b>Click Here For Excel-Exportable Copy Of This Report</b></a>)\n"; 
  print "</pre></table><hr>"; 

  &msg("reportProcess - Done");
}


#-----------------------------------------------------------------------------
sub sshDBMSSQL
#-----------------------------------------------------------------------------
{
  &msg("ssh'ing to Host=$Host Userid=$Userid");

  $lstring = "-l $Userid" if $Userid ne "";

  $cmdpfx = "ssh $Host $lstring '";
  if ($Perl_Path ne "")
  {
    $perlpath = "$Perl_Path";
    $perlpath =~ s/\\/\//g;
  }
  else
  {
    $perlpath = "perl";
  }

  if ($ssh_slash eq "f")
  {
    $cmd = "${cmdpfx}$perlpath /tmp/dbamon_mssql.pl up WWW'";
  }
  else
  {
    #$cmd = "${cmdpfx}$perlpath \\\\temp\\\\dbamon_mssql.pl up WWW'";
    $cmd = "${cmdpfx}$perlpath dbamon_mssql.pl up WWW'";
  }

  &msg("Issuing: $cmd");

  print  "#---- Start of 'remsh' Output: ------------------------------------------------------------------\n";
  system("$cmd 2>&1 | tee $tmpfile");
  print  "#---- End of 'remsh' Output: --------------------------------------------------------------------\n";

  if (`cat $tmpfile` eq "")
  {
    &error("END_OF_PROBE Not Found - 'remsh' Output Is NULL - The 'Remote Shell' Service is not working on $Host");
  }

  if (`cat $tmpfile` !~ /END_OF_PROBE/)
  {
    &error("END_OF_PROBE Not Present In Output - This means that DBAmon is NOT WORKING for this instance");
  }
}

#-----------------------------------------------------------------------------
sub sshDBOracleNT
#-----------------------------------------------------------------------------
{
  &msg("ssh'ing to Host=$Host Userid=$Userid");

  $lstring = "-l $Userid" if $Userid ne "";

  $cmdpfx = "ssh $Host $lstring '";
  if ($Perl_Path ne "")
  {
    $perlpath = "$Perl_Path";
    $perlpath =~ s/\\/\//g;
  }
  else
  {
    $perlpath = "perl";
  }

  if ($ssh_slash eq "f")
  {
    $cmd = "${cmdpfx}$perlpath /tmp/dbamon_orant.pl $ORACLE_SID up WWW'";
  }
  else
  {
    #$cmd = "${cmdpfx}$perlpath \\\\temp\\\\dbamon_orant.pl $ORACLE_SID up WWW'";
    $cmd = "${cmdpfx}$perlpath dbamon_orant.pl $ORACLE_SID up WWW'";
  }

  &msg("Issuing: $cmd");

  print  "#---- Start of 'remsh' Output: ------------------------------------------------------------------\n";
  system("$cmd 2>&1 | tee $tmpfile");
  print  "#---- End of 'remsh' Output: --------------------------------------------------------------------\n";

  if (`cat $tmpfile` eq "")
  {
    &error("END_OF_PROBE Not Found - 'remsh' Output Is NULL - The 'Remote Shell' Service is not working on $Host");
  }

  if (`cat $tmpfile` !~ /END_OF_PROBE/)
  {
    &error("END_OF_PROBE Not Present In Output - This means that DBAmon is NOT WORKING for this instance");
  }
}









#-----------------------------------------------------------------------------
sub remshSAP
#-----------------------------------------------------------------------------
{
  if ($Userid eq "")
  {
    $Userid = lc $SAPSYSTEMNAME . "adm";
  }
  &msg("remsh'ing to Host=$Host Userid=$Userid");
  $lstring = "-l $Userid" if $Userid ne "";

  $cmdpfx = "remsh $Host $lstring '. .profile ;";

  &msg("Issuing: $probe_dir/dbamon_sap.pl $SAPSYSTEMNAME up");
  $cmd = "$cmdpfx $probe_dir/dbamon_sap.pl $SAPSYSTEMNAME up'";

  print  "#---- Start of 'remsh' Output: ------------------------------------------------------------------\n";
  system("$cmd 2>&1 | tee $tmpfile");
  print  "#---- End of 'remsh' Output: --------------------------------------------------------------------\n";

  if (`cat $tmpfile` !~ /END_OF_PROBE/)
  {
    &error("END_OF_PROBE Not Present In Output - This means that DBAmon is NOT WORKING for this instance");
  }
}

#-----------------------------------------------------------------------------
sub pingHost
#-----------------------------------------------------------------------------
{
  &msg("Performing ping test to Host=$Host");

  $rc = system("/usr/sbin/ping $Host 64 1 | tee $tmpfile | grep 'received, 0% packet loss' > /dev/null 2>&1");
  if ($rc != 0)
  {
    $err_details = `cat $tmpfile`; 
    &msg("Error details:\n<b>$err_details</b>"); 
    &error("Cannot ping host=$Host");
  }

  ##&msg("ping Successful");
}

#-----------------------------------------------------------------------------
sub getInstance
#-----------------------------------------------------------------------------
{
  ##&msg("DEBUG - before inst=$inst"); 
  if ($ckin eq "" || $ckin eq ".")
  {
    &msg("Selecting DBC key for modein=$modein dbcfilein=$dbcfilein");
    # Count tasks
    $statement  = "
      select 
	i_hosts,
        dbamonmode
      from 
	dbamon.dbcactive
      where
	text like '%DBCFileName=$dbcfilein%' 
        and dbamonmode like '$modein%'
	";
    ##print "$statement\n";
    $sth = $dbh->prepare($statement) ||
	    &error('Failed_on_DB_prepare_in_chgEnt');
    $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

    $foundit = 0;

    while (@Data = $sth->fetchrow_array)
    {
      $inst = $Data[0];
      $mode = $Data[1];
      $foundit = 1;
    }
    &msg("Selected inst=$inst mode=$mode");

    if (! $foundit)
    {
      &msg("Ran sql: \n$statement");
      &error("Could not find DBCACTIVE row for this instance");
    }
  }
  ##&msg("DEBUG - after inst=$inst"); 

  &msg("Selecting DBC data for mode=$mode inst=$inst");
  # Count tasks
  $statement  = "
    select 
      text
    from 
      dbamon.dbcactive
    where
      dbamonmode = '${mode}'
      and i_hosts = '$inst'
      and text not like '#%'";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  while (@Data = $sth->fetchrow_array)
  {
    ##print "$Data[0] \n";
    ##$text = $Data[0];
    $_ = $Data[0];
    @words = split;
    chop($parm  = $words[0]);
    $value = $words[1];
    ##print "parm=$parm value=$value \n";
    if ($parm eq "OraApps_FS_Check") 
    {
      $cmd = "\$${parm} .= \"$value \"";
    }
    else
    {
      $cmd = "\$${parm} = \"$value\"";
    }
    ##&msg("DEBUG cmd=$cmd");
    eval("$cmd"); 
  }

  if ($Host eq "")
  {
    &msg("<b>Error: I could not read the host definition for this instance</b>");
    &msg("<b>       from the DBAmon Oracle repository.</b>");
    &msg("<b>       DBAmon must be initializing.</b>");
    exit 1;
  }

  # Defaults
  $DBMS = "Informix" if $DBMS eq "";
  if ($DBMS eq "SAP" && $Userid eq "")
  {
    $Userid = lc $SAPSYSTEMNAME . "adm";
  }

  # Ensure that we have the right instance
  $str = "${Host}${DBMS}${Title1}${ORACLE_SID}";
  chop($ck = `echo "$str" | cksum | awk '{ print \$1 }'`);
 
  &msg("Host=$Host Title1=$Title1 DBMS=$DBMS Comm_Method=$Comm_Method str=$str ck=$ck");

  if ($ckin ne "" && $ckin ne "." && $ckin ne $ck)   
  {
    system("echo ' ' | mailx -s 'dbamon_www_check.pl CKERR ($zcli) $inst $Title1 $DBMS ck=$ck ckin=$ckin [AUTO]' oracle");
    &msg("<font color=red>The information for this instance does not verify correctly with the WWW instance that you selected.</font>");
    &msg("<font color=red>This probably means that an instance was added or removed recently, and the corresponding DBAmon</font> ");
    &msg("<font color=red>has not finished its current interaion. Please retry later.</font>");
    exit 1;
  }
}


#-----------------------------------------------------------------------------
sub init
#-----------------------------------------------------------------------------
{
  if ($mode eq "TEST")
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc_test";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys_test.html";
  }
  else
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys.html";
  }
  
  chop($os = `grep ORACLE_SID:  $rcfile | awk '{ print \$2}'`);
  chop($oh = `grep ORACLE_HOME: $rcfile | awk '{ print \$2}'`);

  ##&msg("Setting Oracle Env.");
  $ENV{"ORACLE_SID"} = $os;
  $ENV{"ORACLE_HOME"} = $oh;
  ##system("env | grep ORACLE");

  chop($date = `date`);
  chop($wsname = `hostname`);
  chop($wsnamef = `nslookup $wsname | grep Name: | awk '{ print \$2 }'`);

}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("Starting version=$version mode=$mode inst=$inst ckin=$ckin arg3=$arg3 arg4=$arg4");

&init;

&connectDB;

&getInstance;

##system("echo ' ' | mailx -s 'dbamon_www_check.pl ($zcli) $Host $Title1 $DBMS [AUTO]' oracle");

if ($Comm_Method ne "ssh") 
{ 
  &pingHost; 
}

if ($Comm_Method ne "ssh" && 
    $DBMS ne "OracleNT"   &&
    $DBMS ne "MSSQL")
{ 
  &download; 
}
elsif ($Comm_Method ne "ssh" &&
       (
       $DBMS eq "OracleNT"   ||
       $DBMS eq "MSSQL") )
{ 
  &downloadNT; 
}
elsif ($Comm_Method eq "ssh" && 
       $DBMS eq "Oracle") 
{ 
  &downloadSCP; 
}
elsif ($Comm_Method eq "ssh" && 
       $DBMS eq "Informix") 
{ 
  &downloadSCP; 
}
elsif ($Comm_Method eq "ssh" && 
       $DBMS eq "MSSQL") 
{ 
  &downloadNTSCP; 
}
elsif ($Comm_Method eq "ssh" && 
       $DBMS eq "OracleNT") 
{ 
  &downloadNTSCP; 
}
else
{
  &msg("<b>DBMS: $DBMS Comm_Method: $Comm_Method - Not yet supported by this module</b>"); 
  system("echo ' ' | mailx -s 'dbamon_www_check.pl NoDownload DBMS=$DBMS Comm_Method=$Comm_Method Host=$Host [AUTO]' oracle");
  exit 1;
}

## print "<hr><p STYLE=\"background: black\"><font color=lime>";

if    ($Comm_Method ne "ssh" && $DBMS eq "Oracle")     { &remshDBOracle } 
elsif ($Comm_Method eq "ssh" && $DBMS eq "Oracle")     { &sshDBOracle } 
else    { &msg("<b>DBMS=$DBMS Comm_Method=$Comm_Method - Not supported by this module</b>"); }

## print "<hr></font>";

&msg("Done");
#system("rm $tmpfile > /dev/null 2>&1");
exit 0;
