#-------------------------------------------------------------------------------
sub DownloadSWWin
#-------------------------------------------------------------------------------
#
{
  ($thishost) = @_;

  #---- Vars
  my $filemask = ""; 
  my $local_debug = 0; 

  &debug($thishost,"BEFORE - This probe=$probe[$thishost]"); 

  #---- Copy SQLREQFILE to create REQUIRE FILE
  &sqlReqFile;
  if    ($dbms[$i_rm] eq "MSSQL")    { &sqlReqFile;  } 
  elsif ($dbms[$i_rm] eq "OSWin")    { &osWinReqFile; } 

  #---- $using_copssh=1 if we're only using COPSSH
  my $using_copssh = 1; 

  #---- If we are using COPSSH, set this manually
  $openssh[$thishost] = 1 if $using_copssh;

  if (! $using_copssh)
  {
    #---- Do this every iteration !!!
    #---- Get a list of the services running
    &logit("(DEBUG) Listing running services",$thishost);
    print "DownloadSWWin - $titleraw[$thishost] | Performing NET START\n"; 
    &remsh("net start",$tmpfl2,$thishost);
    system("cat $tmpfl2") if $local_debug; 
    my $services_list = `cat $tmpfl2`;
    if ($services_list =~ /OpenSSH/i)
    {
      $openssh[$thishost] = 1;
      if    ($dbms[$i_rm] eq "MSSQL")    { $probe[$thishost] = 'dbamon_mssql.pl'; } 
      elsif ($dbms[$i_rm] eq "OracleNT") { $probe[$thishost] = 'dbamon_orant.pl'; } 
      elsif ($dbms[$i_rm] eq "OSWin")    { $probe[$thishost] = 'dbamon_oswin.pl'; } 

      &debug($thishost,"This server runs OpenSSH - probe=$probe[$thishost]"); 
    }
    else
    {
      $openssh[$thishost] = 0;
      &debug($thishost,"This server does NOT run OpenSSH"); 
    }
  }

  &debug($thishost,"AFTER - This probe=$probe[$thishost]"); 

  #---- Remove any old /tmp/dbamon* files - NOT needed if you're using COPSSH
  
  if (! $using_copssh)
  {
    &logit("(DEBUG) Removing old download files",$thishost);
    if ($comm_method[$thishost] eq "ssh")
    {
      $must_connect = 0;
      ##print "DEBUG - rming ssh temp\n";
      &remsh("rm -f \\\\temp\\\\dbamon*.pl",$tmpfl2,$thishost);

    }
    else
    {
      $must_connect = 1;
      &remsh("erase \\temp\\dbamon*.pl",$tmpfl2,$thishost);
    }
  }

  #---- This doesn't make sense - we haven't yet set $up
  #if ($up[$thishost] eq "N")     # Remsh error
  #{
  #  &logit("(Connect Error) - turning off download flag",$thishost);
  #  $up[$thishost] = "D";
  #  $download_flag[$thishost] = 0;
  #  return;
  #}

  #
  # Until an rcp bug is fixed we have to remsh to server and then rcp the
  # S/W back to \temp
  #
  # Download pgms from /opt/dbamon/bin/download to temp
  #

  if ($dbms[$thishost] eq "MSSQL")    { $filemask = "mssql" }
  if ($dbms[$thishost] eq "OracleNT") { $filemask = "orant" }
  if ($dbms[$thishost] eq "OSWin")    { $filemask = "oswin" }

  #---- This is to prevent strange errors below
  #---- Old
  # system("rm $tmpfl2 2>&1");
  #---- New
  unlink "$tmpfl2" if -e "$tmpfl2";

  system("touch $tmpfl2");

  ##print "thishost=$thishost filemask=$filemask ntrcpbug=$ntrcpbug[$thishost]\n";

  if ($ntrcpbug[$thishost] eq "Y")
  {
    $cmd = "remsh $hostname[$thishost] 'rcp ${wsnamef}.${dbamon_userid}:/opt/dbamon/bin/download/*$filemask* .' 2>&1 | grep -v '^\$' > $tmpfl2";
    $rc = system($cmd);
    ## $cmd = "remsh $hostname[$thishost] 'move *${filemask} \\temp\\dbamon_${filemask}.pl' 2>&1 | grep -v '^\$' >> $tmpfl2 2>&1";
    $cmd = "remsh $hostname[$thishost] 'move *${filemask}* \\temp' 2>&1 | grep -v '^\$' >> $tmpfl2 2>&1";
    $rc = system($cmd);
    ##print "rc=$rc cmd=$cmd\n";
  }
  else
  {
    if ($comm_method[$thishost] eq "ssh")
    {
      if ($openssh[$thishost] == 1)
      {
        #---- COPSSH Uses this one - to local home dir on TARGET
        ##$cmd = "scp /opt/dbamon/bin/download/*${filemask}* $tmpdir/dbamon_mssql_req.pl '$userid[$thishost]\@$hostname[$thishost]:' 2>&1 | grep -v '^\$' > $tmpfl2 2>&1";
        $cmd = "scp /opt/dbamon/bin/download/*${filemask}* $tmpdir/$reqfile[$thishost] '$userid[$thishost]\@$hostname[$thishost]:' 2>&1 | grep -v '^\$' > $tmpfl2 2>&1";
        ##print "HIT cmd=($cmd)\n"; 
      }
      else
      {
        $cmd = "scp /opt/dbamon/bin/download/*${filemask}* $tmpdir/dbamon_mssql_req.pl '$userid[$thishost]\@$hostname[$thishost]:/tmp' 2>&1 | grep -v '^\$' > $tmpfl2 2>&1";
      }
    }
    else
    {
      #$cmd = "remsh $hostname[$thishost] 'rcp ${wsnamef}.${dbamon_userid}:/opt/dbamon/bin/download/*${filemask}* temp' 2>&1 | grep -v '^\$' > $tmpfl2 2>&1";
      #---- Major Change - BB 26Oct04 - send to /temp instead of temp
      $cmd = "remsh $hostname[$thishost] 'rcp ${wsnamef}.${dbamon_userid}:/opt/dbamon/bin/download/*${filemask}* /temp' 2>&1 | grep -v '^\$' > $tmpfl2 2>&1";
    }
    &logit("(DEBUG) Downloading download files - cmd=($cmd)",$thishost);
    $rc = system($cmd);
    &debug($thishost,"rc=$rc cmd=$cmd");

    ##print "HIT-D - rc=$rc\n";  $local_debug=1; 
  }

  if ($local_debug)
  {
    print "DEBUG - tmpfl2 Start Download\n";
    system("cat $tmpfl2");
    print "DEBUG - tmpfl2 End Download\n";
  }

  #---- If file is NOT NULL, then something is wrong
  if (system("test -s $tmpfl2") == 0 && system("grep 'file(s) moved' $tmpfl2 > /dev/null 2>&1") != 0)
  {
    #---- Check for pw expired error
    if (system("grep -i 'expired' $tmpfl2") == 0)
    {
      &event("C",$thishost,"scp/rcp Error - Userid=$userid[$thishost] password expired","DnldPasswd","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
    elsif (system("grep -i 'disabled' $tmpfl2") == 0)
    {
      &event("C",$thishost,"scp/rcp Error - Userid=$userid[$thishost] account disabled","DnldAcct","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
    elsif (system("grep -i 'incorrect' $tmpfl2") == 0)
    {
      &event("C",$thishost,"scp/rcp Error - Userid=$userid[$thishost] login incorrect","DnldIncorr","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
    elsif (system("grep -i 'lost connection' $tmpfl2") == 0)
    {
      &event("C",$thishost,"scp/rcp Error - Userid=$userid[$thishost] lost connection","DnldLostConn","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
    else
    {
      &event("C",$thishost,"Undiagnosed scp/rcp Error - Userid=$userid[$thishost]","DnldErrUnk","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
  }

  #---- Completion Message

  $download_flag[$thishost] = 1;
  $up[$thishost] = "";
  $hn = $hostname[$thishost];
  $download_host{$hn} = 1;
  
  &function_cleanup();

  #---- Ensure that /usr/local/bin/perl on the db server points to perl5
  
  &logit("(DEBUG) Running PERL verification",$thishost);
  &remsh("$perlpath[$thishost] -v",$tmpfl2,$thishost);

  system("cat $tmpfl2") if $local_debug;

  if (system("egrep 'This is perl, version 5|This is perl, v5|This is perl 5|perl5' $tmpfl2 > /dev/null") != 0)
  {
    if (system("grep 'name specified is not recognized' $tmpfl2 > /dev/null") == 0)
    { 
      system("echo 'Command Not Found - Check Perl_Path: DBC Parameter' > $tmpfl3");
    }
    else
    {
      system("echo 'Perl5 check - Undiagnosable Error:' > $tmpfl3");
      system("cat -v $tmpfl2 >> $tmpfl3");
    }
    &event("C",$thishost,"$perlpath[$thishost] Does Not Invoke Perl Version 5","PerlVer","DBA503C",$tmpfl3);
    $up[$thishost] = "D";
    return;
  }
  &logit("OK",$thishost);
}     
#-------------------------------------------------------------------------------
1;
