# -----------------------------------------------------------------------------
sub infPerf
{
  ($thishost) = @_;

  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1;
  }
    
  &remsh("onstat -p",$tmpfl4,$thishost);
  ##system("cat $tmpfl4");

  if (system("grep -i 'shared memory not' $tmpfl4") == 0) 
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  $dsk_flag = 0;
  $ov_flag = 0;
  $done_flag = 0;
  $check_flag = 0;

  &logDetails($thishost,"<h3>Informix Performance Metrics</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Metric<th>Value");

  open(TMPFL4, "$tmpfl4") || &error_msg("Can't open input $tmpfl4 - $!");
  while(<TMPFL4>)
  {
    if ($done_flag) { last; }

    &parse;
    
    ##print "NF=$NF F0=$F0 F1=$F1 dsk_flag=$dsk_flag done_flag=$done_flag \n";
    if ($dsk_flag)
    {
      $bufreads = $F3;
      $rh = $F4;
      $wh = $F8;

      if ($rh > 0 && $rh < $t_readhit[$thishost] && $bufreads > 10000000 && $t_readhit[$thishost] ne "")
      {
        &event("P",$thishost,"Read Hit Ratio $rh < Threshold of $t_readhit[$thishost]","RHit","DBA240I",$tmpfl4);
	$check_flag = 1;
      }

      if ($wh > 0 && $wh < $t_writehit[$thishost] && $bufreads > 10000000 && $t_writehit[$thishost] ne "")
      {
        &event("P",$thishost,"Write Hit Ratio $wh < Threshold of $t_writehit[$thishost]","WHit","DBA241I",$tmpfl4);
	$check_flag = 1;
      }
      $dsk_flag = 0
    }

    if ($ov_flag)
    {
      $ovtbls = $F1;
      $ovlock = $F2;
      $ovuser = $F3;
      $ovbuff = $F4;

      if ($ovtbls != 0)
      {
        &event("W",$thishost,"ovtbls Value: $ovtbls Non-Zero","OVTbls","DBA212W",$tmpfl4);
	$check_flag = 1;
      }
	
      if ($ovlock != 0)
      {
        &event("W",$thishost,"ovlock Value: $ovlock Non-Zero","OVLock","DBA213W",$tmpfl4);
	$check_flag = 1;
      }

      if ($ovuser != "0")
      {
        &event("W",$thishost,"ovuserthread Value: $ovuser Non-Zero","OVUser","DBA214W",$tmpfl4);
	$check_flag = 1;
      }

      if ($ovbuff != 0)
      {
        &event("W",$thishost,"ovbuff Value: $ovbuff Non-Zero","OVBuff","DBA215W",$tmpfl4);
	$check_flag = 1;
      }

      $ov_flag = 0;
      $done_flag = 1;

    }

    if ($F1 eq "dskreads") { $dsk_flag = 1 }
    if ($F1 eq "ovtbls")   { $ov_flag = 1 }
  }
  close(TMPFL4);

  &logDetails($thishost,"<tr><th>$f_s Read Hit Ratio:<td align=right>$f_s $rh");
  &logDetails($thishost,"<tr><th>$f_s Write Hit Ratio:<td align=right>$f_s $wh");
  &logDetails($thishost,"<tr><th>$f_s Bufreads:<td align=right>$f_s $bufreads");
  &logDetails($thishost,"<tr><th>$f_s Ovbuff:<td align=right>$f_s $ovbuff");
  &logDetails($thishost,"<tr><th>$f_s Ovtbls:<td align=right>$f_s $ovtbls");
  &logDetails($thishost,"<tr><th>$f_s Ovlock:<td align=right>$f_s $ovlock");
  &logDetails($thishost,"<tr><th>$f_s Ovuser:<td align=right>$f_s $ovuser");
  &logDetails($thishost,"</table><hr>");

  if ($check_flag == 0) 
  {
    &logit("OK",$thishost);
  }
}     
# -----------------------------------------------------------------------------
1;
